﻿using System.Runtime.Serialization.Json;
using System.Text;
using System.Xml;

namespace CoreLibrary.Persistance
{
    public class PersistanceJSON : IPersistance
    {

        public T[] Charger<T>() where T : IEstPersistant
        {
            string dossierAvant = Directory.GetCurrentDirectory();

            string dossier = Path.Combine(dossierAvant, "../../../..");
            string fichier = $"{typeof(T).Name}.json";


            bool c = Directory.Exists(dossier);

            if (!c) 
                return [];

            Directory.SetCurrentDirectory(dossier);

            if (!File.Exists(fichier))
                return [];

            DataContractJsonSerializer jsonSerializer = new DataContractJsonSerializer(typeof(T[]));
            T[] elements;

            using (FileStream s = File.OpenRead(fichier))
            {
                elements = jsonSerializer.ReadObject(s) as T[];
            }

            return elements;
        }

        public void Enregistrer<T>(T[] elements) where T : IEstPersistant
        {
            string dossier = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.ApplicationData), "Mastermind");
            string fichier = $"{typeof(T).Name}.json";

            if (!Directory.Exists(dossier))
                Directory.CreateDirectory(dossier);

            Directory.SetCurrentDirectory(dossier);

            DataContractJsonSerializer jsonSerializer = new DataContractJsonSerializer(typeof(T[]));

            using(FileStream s = File.Create(fichier))
            {
                using(XmlDictionaryWriter writer = JsonReaderWriterFactory.CreateJsonWriter(
                                        s,
                                        Encoding.UTF8,
                                        false,
                                        true))
                {
                    jsonSerializer.WriteObject(writer, elements);
                }
            }
        }
    }
}